#include "Optimizer.h"
#ifndef FT
#include "lbfgsb/lbfgsb.h"
#endif

/** declaration of lbfgs-b variables
 nbd is an INTEGER array of dimension n that must be set by the
 user to the type of bounds imposed on the variables:
 nbd(i)=0 if x(i) is unbounded,
    1 if x(i) has only a lower bound,
    2 if x(i) has both lower and upper bounds,
    3 if x(i) has only an upper bound.
 factr is a DOUBLE PRECISION variable that must be set by the user.
 It is a tolerance in the termination test for the algorithm.
 The iteration will stop when

    (f^k - f^{k+1})/max{|f^k|,|f^{k+1}|,1} <= factr*epsmch

  where epsmch is the machine precision which is automatically
  generated by the code. Typical values for factr on a computer
  with 15 digits of accuracy in double precision are:
  factr=1.d+12 for low accuracy;
    1.d+7  for moderate accuracy;
    1.d+1  for extremely high accuracy.
  The user can suppress this termination test by setting factr=0.
**/

#ifndef FT
double factr, pgtol;
integer nmax, mmax;
int iter = 0;
int nwa;
static integer *iwa, *nbd, taskValue, *task, iprint, csaveValue, *csave, isave[44];
static logical lsave[4];
double *wa, *l, *u, dsave[29];
#endif

Optimizer::Optimizer(VelocityModel *velocityModel, Config *config) {
  int id, comm_sz, nbdaux;
  double laux, uaux;
  MPI_Comm_size(MPI_COMM_WORLD, &comm_sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &id);
  fConverged = false;
  fConfig = config;
  SimpleConfigTextFile *simpleConfigTextFile = static_cast<SimpleConfigTextFile *>(fConfig);
  try {
    fMaxSteps = simpleConfigTextFile->Get<int>("n_iter");
  } catch (const std::exception &e) {
    if (!id) {
      std::cout << "Number max of FG evaluations set by default 999" << '\n';
    }
    fMaxSteps = 999;
  }
  try {
    fMaxUpdatesIteration = simpleConfigTextFile->Get<int>("max_viter");
  } catch (const std::exception &e) {
    if (!id) {
      std::cout << "Number max of Velocity Model update set by default 100" << '\n';
    }
    fMaxUpdatesIteration = 100;
  }
  nmax = velocityModel->fgrid.on;
  // FIXME: why using a hard-coding number?
  // Answer: This is a suggestion from the library creators
  mmax = 9;
  integer n = velocityModel->fgrid.on;
  nwa = (2 * mmax + 5) * nmax + 11 * mmax * mmax + 8 * mmax;
  wa = new double[nwa];
  iwa = new integer[3 * nmax];
  l = new double[n];
  u = new double[n];
  nbd = new integer[n];
  task = &taskValue;
  csave = &csaveValue;

  if (id == 0) {
    if (FileExists("fcost.txt")) {
      remove("fcost.txt");
    }
    velocityModel->Print();
  }

  nbdaux = simpleConfigTextFile->Get<int>("lbfgsb");
  laux = simpleConfigTextFile->Get<double>("lbfgsb_lower_bound");
  uaux = simpleConfigTextFile->Get<double>("lbfgsb_upper_bound");
  for (int i = 0; i < n; i++) {
    l[i] = laux;
    u[i] = uaux;

    /* ! Lower and upper bounds
     nbd=0 => unbounded
     nbd=1 => only lower bound
     nbd=2 => lower and upper bounds
     nbd=3 => only upper bound */
    nbd[i] = nbdaux;
  }
  /**!factr=1.d+12 for low accuracy;
   * 1.d+7  for moderate accuracy;
   * 1.d+1  for extremely high accuracy.
   * The user can suppress this termination test by setting factr=0.
   **/
  factr = 1.e7;
  pgtol = 1.e-9;
  *task = (integer) START;

  /* iprint = 99 => print messages
     iprint = -1 => no printing of messages */
  iprint = -1;
}

Optimizer::~Optimizer() {
  delete[] iwa;
  delete[] nbd;
  delete[] wa;
  delete[] l;
  delete[] u;
}

// cppcheck-suppress unusedFunction
void Optimizer::Update(VelocityModel *model, Adjoint *adjoint) {
  int id, comm_sz;
  MPI_Comm_size(MPI_COMM_WORLD, &comm_sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &id);
  double total_misfit = adjoint->t_misfit;
  double *gradient = adjoint->gradient;
  setulb(&nmax, &mmax, model->fOriginalModel, l, u, nbd, &total_misfit, gradient, &factr, &pgtol,
         wa, iwa, task, &iprint, csave, lsave, isave, dsave);

  if (IS_FG(*task)) {
    /*        the minimization routine has returned to request the */
    /*        function f and gradient g values at the current x. */
    fConverged = false;

    adjoint->Run();

    if (id == 0) {
      std::cout << "--------------COMPUTING NEW GRADIENT------------------\n";
      if (*task == 11) {
        std::cout << "Number of FG evaluations = " << isave[33] << ".   Performing line search.\n";
      } else if (*task == 12) {
        std::cout << "Number of FG evaluations = " << isave[33] << ".   Starting LBFGS-B.\n";

        // saving the velocity model at the first iteration if verbose
        // is on
#ifdef VERBOSE
        model->SaveVModelIter(0, fConfig->Get("proj_dir"));
#endif
      }
    }
  } else if (*task == NEW_X) {
    fConverged = false;
    fCurUpdateIteration++;
    if (id == 0) {
      std::cout << "------------------MODEL UPDATED-----------------------\n";
      FILE *fp;
      fp = fopen("fcost.txt", "a");
      fprintf(fp, "%ld %lf\n", isave[29], total_misfit);
      fclose(fp);
      std::cout << "Number of FG evaluations = " << isave[33]
                << ".   Model updated with gradient.\n";

      /*        We now wish to print the following information at each */
      /*        iteration: */
      /*          1) the current iteration number, isave(29), */
      /*          2) the total number of f and g evaluations, isave(33),
       */
      /*          3) the value of the objective function f, */
      /*          4) the norm of the projected gradient,  dsave(12) */
      printf("Iterate %5ld  nfg = %4ld   f = %6.4e   |proj g| = %6.4e\n", isave[29], isave[33],
             total_misfit, dsave[12]);

#ifdef VERBOSE
      // saving the velocity model at each iteration if verbose is on
      model->SaveVModelIter(isave[29], fConfig->Get("proj_dir"));
      // saving the gradient of last iteration
      BinaryFileHandler fileHandler(fConfig->Get("proj_dir"));
      fileHandler.WriteFile<double>(FILENAME_GRADIENT, gradient, model->fgrid.on);
#endif
    }
  } else if (IS_CONVERGED(*task)) {
    fConverged = true;
    if (id == 0) {
      std::cout << "--------------ALGORITHM HAS CONVERGED-----------------\n";
      if (*task == 21) {
        std::cout << "Number of FG evaluations = " << isave[33]
                  << ".   NORM OF PROJECTED GRADIENT <= PGTOL.\n";
      } else if (*task == 22) {
        std::cout << "Number of FG evaluations = " << isave[33]
                  << ".   REL REDUCTION OF F <= FACTR*EPSMCH.\n";
      }
    }

    // saving the final velocity model
    model->SaveVModelFinal(fConfig->Get("proj_dir"));
  } else {
    fConverged = false;
    if (id == 0) {
      std::cout << "-----------------CHECK TASK VALUE---------------------\n";
      std::cout << "Number of FG evaluations = " << isave[33] << ".   Task = " << *task << ".\n";
    }
  }

  /* Terminate if the total number of f and g evaluations */
  /*             exceeds fMaxSteps. This value should be one of */
  /*             input parameters of the code.            */
  if (isave[33] > fMaxSteps) {
    fConverged = true;
    *task = STOP_ITER;
    if (id == 0) {
      std::cout << "----------------------FORCED STOP---------------------\n";
      printf("MAXIMUM NUMBER OF F AND G EVALUATIONS REACHED.\n");
      // saving the final velocity model
      model->SaveVModelFinal(fConfig->Get("proj_dir"));
    }
  }
  /**
   * Terminate if the total of Velocity Update equals fMaxUpdatesIteration
   */
  if (fCurUpdateIteration == fMaxUpdatesIteration) {
    fConverged = true;
    *task = STOP_ITER;
    if (id == 0) {
      std::cout << "----------------------FORCED STOP---------------------\n";
      printf("MAXIMUM NUMBER OF VELOCITY UPDATE REACHED.\n");
      // saving the final velocity model
      model->SaveVModelFinal(fConfig->Get("proj_dir"));
    }
  }
}